public inbox for linux-kernel@vger.kernel.org
 help / color / mirror / Atom feed
* [PATCH] [next] initramfs: Parse KBUILD_BUILD_TIMESTAMP as UTC date
@ 2023-07-29  5:02 Paulo Miguel Almeida
  2023-08-16  6:38 ` Nicolas Schier
  2023-08-18  0:32 ` Andrew Donnellan
  0 siblings, 2 replies; 4+ messages in thread
From: Paulo Miguel Almeida @ 2023-07-29  5:02 UTC (permalink / raw)
  To: masahiroy, bgray, ajd, n.schier
  Cc: paulo.miguel.almeida.rodenas, linux-kernel, keescook

When KBUILD_BUILD_TIMESTAMP is specified, the date command will parse
it to Unix Epoch time in UTC. However, the date command is
timezone-aware so it will convert from the local timezone to UTC first
which hits some of the sanity checks added on commit 5efb685bb3af1
("initramfs: Check negative timestamp to prevent broken cpio archive")

This creates an edge case for the UTC+<N> part of the world. For instance

 - In New Zealand (UTC+12:00):
	$ date -d"1970-01-01" +%s
	-43200

	$ make KBUILD_BUILD_TIMESTAMP=1970-01-01
	make[1]: Entering directory '<snip>/linux/'
	  GEN     Makefile
	  DESCEND objtool
	  INSTALL libsubcmd_headers
	  CALL    ../scripts/checksyscalls.sh
	  GEN     usr/initramfs_data.cpio
	ERROR: Timestamp out of range for cpio format
	make[4]: *** [../usr/Makefile:76: usr/initramfs_data.cpio] Error 1

 - In Seattle, WA (UTC-07:00):
	$ date -d"1970-01-01" +%s
	32400

	$ make KBUILD_BUILD_TIMESTAMP=1970-01-01
	<builds fine>

Parse KBUILD_BUILD_TIMESTAMP date string as UTC so no localtime
conversion is done which fixes the edge case aforementioned.

Signed-off-by: Paulo Miguel Almeida <paulo.miguel.almeida.rodenas@gmail.com>
---
 usr/gen_initramfs.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/usr/gen_initramfs.sh b/usr/gen_initramfs.sh
index 14b5782f961a..a90316d9a080 100755
--- a/usr/gen_initramfs.sh
+++ b/usr/gen_initramfs.sh
@@ -221,7 +221,7 @@ while [ $# -gt 0 ]; do
 			shift
 			;;
 		"-d")	# date for file mtimes
-			timestamp="$(date -d"$1" +%s || :)"
+			timestamp="$(date -d"$1" -u +%s || :)"
 			if test -n "$timestamp"; then
 				timestamp="-t $timestamp"
 			fi
-- 
2.40.1


^ permalink raw reply related	[flat|nested] 4+ messages in thread

end of thread, other threads:[~2023-08-21  7:45 UTC | newest]

Thread overview: 4+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2023-07-29  5:02 [PATCH] [next] initramfs: Parse KBUILD_BUILD_TIMESTAMP as UTC date Paulo Miguel Almeida
2023-08-16  6:38 ` Nicolas Schier
2023-08-18  0:32 ` Andrew Donnellan
2023-08-21  7:45   ` Paulo Miguel Almeida

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox